;CodeVisionAVR C Compiler V1.24.2 Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 16,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 256 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Akvarko.vec"
	.INCLUDE "Akvarko.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.2 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 15.2.2008
;      12 Author  : Martin Satek                    
;      13 Company : Akvarista                  
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega8
;      18 Program type        : Application
;      19 Clock frequency     : 16,000000 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 256
;      23 *****************************************************/
;      24 
;      25 #include <mega8.h>   
;      26 #include <delay.h> 
;      27 #include <stdlib.h> 
;      28 #include <math.h> 
;      29 #define xtal 16000000
;      30 
;      31 #define SETBIT(ADRESS,BIT)	(ADRESS |=(1<<BIT))
;      32 #define CLEARBIT(ADRESS,BIT)	(ADRESS &=~(1<<BIT)) 
;      33 
;      34 #define zarivka 0		// zivky
;      35 #define minus 1		        // zporn napt
;      36 #define rele 2                  // Rezerva
;      37 
;      38 
;      39 // Alphanumeric LCD Module functions
;      40 #asm
;      41    .equ __lcd_port=0x12
   .equ __lcd_port=0x12
;      42 #endasm

;      43 #include <lcd.h>        
;      44 
;      45 unsigned int rozedneni;      
;      46 unsigned int stmivani;
;      47 unsigned int vykon;    
;      48 
;      49 unsigned int tim_rozedneni;    // [1min]
;      50 unsigned int tim_stmivani;     // [1min]
;      51 unsigned int tim_vykon;   
_tim_vykon:
	.BYTE 0x2
;      52 
;      53 long int tim_aktualne;         // aktuln as [0.1s]
_tim_aktualne:
	.BYTE 0x4
;      54 unsigned int tim_volba;        // zvolen as se kterm se pracuje [0.1s]
_tim_volba:
	.BYTE 0x2
;      55 unsigned int vykon_aktualne;   // aktuln vkon [0.1%]
_vykon_aktualne:
	.BYTE 0x2
;      56 unsigned int vykon_lcd;        // aktuln vkon [%]    
_vykon_lcd:
	.BYTE 0x2
;      57 unsigned char menic; 	       //mni napt 
;      58 float f_aktual;
_f_aktual:
	.BYTE 0x4
;      59 float f_volba;
_f_volba:
	.BYTE 0x4
;      60 float f_vykon;
_f_vykon:
	.BYTE 0x4
;      61 
;      62 char rano_vecer; 
_rano_vecer:
	.BYTE 0x1
;      63 char pozice;     
_pozice:
	.BYTE 0x1
;      64 char minuty;
_minuty:
	.BYTE 0x1
;      65 char sekundy;
_sekundy:
	.BYTE 0x1
;      66 
;      67 
;      68 int LCDn [4];			// pro zapis cisel na LCD
_LCDn:
	.BYTE 0x8
;      69 
;      70 
;      71 #define ADC_VREF_TYPE 0x40                  // analogov pevodnk
;      72 // Read the AD conversion result
;      73 unsigned int read_adc(unsigned char adc_input)
;      74 {

	.CSEG
_read_adc:
;      75 ADMUX=adc_input|ADC_VREF_TYPE;
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
;      76 // Start the AD conversion
;      77 ADCSRA|=0x40;
	SBI  0x6,6
;      78 // Wait for the AD conversion to complete
;      79 while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
;      80 ADCSRA|=0x10;
	SBI  0x6,4
;      81 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
;      82 }
;      83 
;      84 //*****************************************************************
;      85 zobrazeni_nastaveni(void){                // pro zadvn parametr
_zobrazeni_nastaveni:
;      86      
;      87 if(PINC.3==0){                             // pokud stisknu tlatko
	SBIC 0x13,3
	RJMP _0x6
;      88 lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;      89 lcd_putsf("Rano    "); 
	__POINTW1FN _0,0
	RCALL SUBOPT_0x1
;      90 pozice = 2;
	RCALL SUBOPT_0x2
;      91 lcd_gotoxy(0,1);    
	RCALL SUBOPT_0x3
;      92 lcd_putsf("        ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x1
;      93 if(tim_rozedneni >= 100) pozice = pozice -1;         // posun sel na LCD
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R10,R30
	CPC  R11,R31
	BRLO _0x7
	RCALL SUBOPT_0x4
;      94 if(tim_rozedneni >= 10) pozice = pozice - 1;  
_0x7:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R10,R30
	CPC  R11,R31
	BRLO _0x8
	RCALL SUBOPT_0x4
;      95 lcd_gotoxy(pozice,1);
_0x8:
	RCALL SUBOPT_0x5
;      96 itoa(tim_rozedneni, LCDn);                       // pepoet sla pro LCD
	ST   -Y,R11
	ST   -Y,R10
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
;      97 lcd_puts(LCDn);                                     // zobrazen sla na LCD
	RCALL _lcd_puts
;      98 lcd_putsf(" min");
	__POINTW1FN _0,18
	RCALL SUBOPT_0x1
;      99 };
_0x6:
;     100 
;     101 if(PINC.4==0){
	SBIC 0x13,4
	RJMP _0x9
;     102 lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;     103 lcd_putsf("Vecer   "); 
	__POINTW1FN _0,23
	RCALL SUBOPT_0x1
;     104 pozice = 2;
	RCALL SUBOPT_0x2
;     105 lcd_gotoxy(0,1);    
	RCALL SUBOPT_0x3
;     106 lcd_putsf("        ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x1
;     107 if(tim_stmivani >= 100) pozice = pozice -1;
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R12,R30
	CPC  R13,R31
	BRLO _0xA
	RCALL SUBOPT_0x4
;     108 if(tim_stmivani >= 10) pozice = pozice - 1;  
_0xA:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R12,R30
	CPC  R13,R31
	BRLO _0xB
	RCALL SUBOPT_0x4
;     109 lcd_gotoxy(pozice,1);
_0xB:
	RCALL SUBOPT_0x5
;     110 itoa(tim_stmivani, LCDn);
	ST   -Y,R13
	ST   -Y,R12
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
;     111 lcd_puts(LCDn);
	RCALL _lcd_puts
;     112 lcd_putsf(" min");
	__POINTW1FN _0,18
	RCALL SUBOPT_0x1
;     113 };
_0x9:
;     114 
;     115 if(PINC.5==0){
	SBIC 0x13,5
	RJMP _0xC
;     116 lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;     117 lcd_putsf("Vykon   ");  
	__POINTW1FN _0,32
	RCALL SUBOPT_0x1
;     118 pozice = 2;
	RCALL SUBOPT_0x2
;     119 lcd_gotoxy(0,1);    
	RCALL SUBOPT_0x3
;     120 lcd_putsf("        ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x1
;     121 if(tim_vykon >= 100) pozice = pozice -1;
	LDS  R26,_tim_vykon
	LDS  R27,_tim_vykon+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLO _0xD
	RCALL SUBOPT_0x4
;     122 if(tim_vykon >= 10) pozice = pozice - 1;  
_0xD:
	LDS  R26,_tim_vykon
	LDS  R27,_tim_vykon+1
	CPI  R26,LOW(0xA)
	LDI  R30,HIGH(0xA)
	CPC  R27,R30
	BRLO _0xE
	RCALL SUBOPT_0x4
;     123 lcd_gotoxy(pozice,1);
_0xE:
	RCALL SUBOPT_0x5
;     124 itoa(tim_vykon, LCDn);
	LDS  R30,_tim_vykon
	LDS  R31,_tim_vykon+1
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
;     125 lcd_puts(LCDn);
	RCALL _lcd_puts
;     126 lcd_putsf(" %  ");
	__POINTW1FN _0,41
	RCALL SUBOPT_0x1
;     127 };
_0xC:
;     128 
;     129 
;     130 
;     131 }
	RET
;     132 //*****************************************************************
;     133 vypocet_nastaveni(void){                              // pepoty analogovho rozsahu 1024 na rozsah teba 120 minut
_vypocet_nastaveni:
;     134 
;     135 tim_rozedneni = 1 + (int)(rozedneni / 8.53); 
	__GETW1R 4,5
	RCALL SUBOPT_0x9
	__PUTW1R 10,11
;     136 
;     137 tim_stmivani =  1 + (int)(stmivani / 8.53); 
	__GETW1R 6,7
	RCALL SUBOPT_0x9
	__PUTW1R 12,13
;     138   
;     139 tim_vykon = 50 + (int)(vykon / 20.4); 
	__GETW1R 8,9
	RCALL SUBOPT_0xA
	__GETD1N 0x41A33333
	RCALL SUBOPT_0xB
	ADIW R30,50
	STS  _tim_vykon,R30
	STS  _tim_vykon+1,R31
;     140 
;     141 }
	RET
;     142 //*****************************************************************
;     143 smycka_menic(void){
_smycka_menic:
;     144 
;     145 delay_ms(2);
	RCALL SUBOPT_0xC
;     146 SETBIT(PORTB,minus); 
	SBI  0x18,1
;     147 delay_ms(2);  
	RCALL SUBOPT_0xC
;     148 CLEARBIT(PORTB,minus);    
	CBI  0x18,1
;     149 delay_ms(2);
	RCALL SUBOPT_0xC
;     150 SETBIT(PORTB,minus); 
	SBI  0x18,1
;     151 delay_ms(2);  
	RCALL SUBOPT_0xC
;     152 CLEARBIT(PORTB,minus);    
	CBI  0x18,1
;     153 }
	RET
;     154 //*****************************************************************
;     155 
;     156 void main(void)
;     157 {
_main:
;     158 // Declare your local variables here
;     159 
;     160 // Input/Output Ports initialization
;     161 // Port B initialization
;     162 // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
;     163 // State7=T State6=T State5=T State4=T State3=1 State2=1 State1=1 State0=1 
;     164 PORTB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x18,R30
;     165 DDRB=0x0F;
	OUT  0x17,R30
;     166 
;     167 // Port C initialization
;     168 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     169 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     170 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     171 DDRC=0x00;
	OUT  0x14,R30
;     172 
;     173 // Port D initialization
;     174 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     175 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     176 PORTD=0x00;
	OUT  0x12,R30
;     177 DDRD=0x00;
	OUT  0x11,R30
;     178 
;     179 // Timer/Counter 0 initialization
;     180 // Clock source: System Clock
;     181 // Clock value: Timer 0 Stopped
;     182 TCCR0=0x00;
	OUT  0x33,R30
;     183 TCNT0=0x00;
	OUT  0x32,R30
;     184 
;     185 // Timer/Counter 1 initialization
;     186 // Clock source: System Clock
;     187 // Clock value: Timer 1 Stopped
;     188 // Mode: Normal top=FFFFh
;     189 // OC1A output: Discon.
;     190 // OC1B output: Discon.
;     191 // Noise Canceler: Off
;     192 // Input Capture on Falling Edge
;     193 TCCR1A=0x00;
	OUT  0x2F,R30
;     194 TCCR1B=0x00;
	OUT  0x2E,R30
;     195 TCNT1H=0x00;
	OUT  0x2D,R30
;     196 TCNT1L=0x00;
	OUT  0x2C,R30
;     197 ICR1H=0x00;
	OUT  0x27,R30
;     198 ICR1L=0x00;
	OUT  0x26,R30
;     199 OCR1AH=0x00;
	OUT  0x2B,R30
;     200 OCR1AL=0x00;
	OUT  0x2A,R30
;     201 OCR1BH=0x00;
	OUT  0x29,R30
;     202 OCR1BL=0x00;
	OUT  0x28,R30
;     203 
;     204  // Timer/Counter 2 initialization
;     205 // Clock source: System Clock
;     206 // Clock value: 15,625 kHz
;     207 // Mode: Phase correct PWM top=FFh
;     208 // OC2 output: Non-Inverted PWM
;     209 ASSR=0x00;
	OUT  0x22,R30
;     210 TCCR2=0x65;   
	LDI  R30,LOW(101)
	OUT  0x25,R30
;     211 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     212 OCR2=0x00;
	OUT  0x23,R30
;     213 
;     214 // External Interrupt(s) initialization
;     215 // INT0: Off
;     216 // INT1: Off
;     217 MCUCR=0x00;
	OUT  0x35,R30
;     218 
;     219 // Timer(s)/Counter(s) Interrupt(s) initialization
;     220 TIMSK=0x00;
	OUT  0x39,R30
;     221 
;     222 // Analog Comparator initialization
;     223 // Analog Comparator: Off
;     224 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     225 // Analog Comparator Output: Off
;     226 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     227 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     228 
;     229 // ADC initialization
;     230 // ADC Clock frequency: 125,000 kHz
;     231 // ADC Voltage Reference: AVCC pin
;     232 // ADC High Speed Mode: Off
;     233 ADMUX=ADC_VREF_TYPE;
	LDI  R30,LOW(64)
	OUT  0x7,R30
;     234 ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
;     235 SFIOR&=0xEF;
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
;     236 
;     237 // LCD module initialization
;     238 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     239 
;     240 // Watchdog Timer initialization
;     241 // Watchdog Timer Prescaler: OSC/2048k
;     242 WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
;     243 WDTCR=0x0F;     
	LDI  R30,LOW(15)
	OUT  0x21,R30
;     244 
;     245 SETBIT(PORTB,rele); 
	SBI  0x18,2
;     246 SETBIT(PORTB,zarivka); 
	SBI  0x18,0
;     247 lcd_gotoxy(0,0);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;     248 lcd_putsf("Katka   ");    
	__POINTW1FN _0,46
	RCALL SUBOPT_0x1
;     249 lcd_gotoxy(0,1);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x3
;     250 lcd_putsf("Pruskova"); 
	__POINTW1FN _0,55
	RCALL SUBOPT_0x1
;     251 
;     252 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0xD
;     253 rano_vecer = 0;
	RCALL SUBOPT_0xE
;     254 vykon_aktualne = 0;
	LDI  R30,0
	STS  _vykon_aktualne,R30
	STS  _vykon_aktualne+1,R30
;     255 vykon_lcd = 0;
	LDI  R30,0
	STS  _vykon_lcd,R30
	STS  _vykon_lcd+1,R30
;     256 tim_aktualne = 0;    
	LDI  R30,0
	STS  _tim_aktualne,R30
	STS  _tim_aktualne+1,R30
	STS  _tim_aktualne+2,R30
	STS  _tim_aktualne+3,R30
;     257 
;     258 
;     259 while (1)
_0xF:
;     260       {
;     261 #asm("WDR");  
	WDR
;     262 rozedneni = read_adc(0);	//as rozednn     
	RCALL SUBOPT_0x0
	RCALL _read_adc
	__PUTW1R 4,5
;     263 stmivani = read_adc(1);		//as stmvn    
	RCALL SUBOPT_0xF
	RCALL _read_adc
	__PUTW1R 6,7
;     264 vykon = read_adc(2);		//as vkon   
	RCALL SUBOPT_0x10
	RCALL _read_adc
	__PUTW1R 8,9
;     265 vypocet_nastaveni();
	RCALL _vypocet_nastaveni
;     266    
;     267 if(rano_vecer==0 & vykon_aktualne==0) SETBIT(PORTB,zarivka);
	RCALL SUBOPT_0x11
	PUSH R30
	LDS  R26,_vykon_aktualne
	LDS  R27,_vykon_aktualne+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __EQW12
	POP  R26
	AND  R30,R26
	BREQ _0x12
	SBI  0x18,0
;     268  
;     269 smycka_menic();
_0x12:
	RCALL SUBOPT_0x12
;     270 smycka_menic();
;     271 smycka_menic();
	RCALL SUBOPT_0x12
;     272 smycka_menic();
;     273 smycka_menic();
	RCALL SUBOPT_0x12
;     274 smycka_menic();
;     275 smycka_menic();
	RCALL SUBOPT_0x12
;     276 smycka_menic();
;     277 smycka_menic();
	RCALL SUBOPT_0x12
;     278 smycka_menic();
;     279 smycka_menic();
	RCALL SUBOPT_0x12
;     280 smycka_menic();
;     281 delay_ms(2);
	RCALL SUBOPT_0xC
;     282 
;     283 //******************************************************
;     284 if(PINB.5==0 & rano_vecer==0) // Rozednn   
	LDI  R30,0
	SBIC 0x16,5
	LDI  R30,1
	RCALL SUBOPT_0x13
	PUSH R30
	RCALL SUBOPT_0x11
	POP  R26
	AND  R30,R26
	BREQ _0x13
;     285 { 
;     286 delay_ms(2);
	RCALL SUBOPT_0xC
;     287 if(PINB.5==0)
	SBIC 0x16,5
	RJMP _0x14
;     288 {
;     289 delay_ms(2);
	RCALL SUBOPT_0xC
;     290 if(PINB.5==0)
	SBIC 0x16,5
	RJMP _0x15
;     291 {
;     292 delay_ms(2);
	RCALL SUBOPT_0xC
;     293 if(PINB.5==0) 
	SBIC 0x16,5
	RJMP _0x16
;     294 { 
;     295 #asm("WDR");
	WDR
;     296 CLEARBIT(PORTB,rele);   // rel pro vypnut analog. vstupu do pevodnku pi startu
	CBI  0x18,2
;     297 delay_ms(100); 
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0xD
;     298 CLEARBIT(PORTB,zarivka);   
	CBI  0x18,0
;     299 delay_ms(1000);   
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0xD
;     300 SETBIT(PORTB,rele);   
	SBI  0x18,2
;     301 tim_volba = tim_rozedneni * 600;
	__GETW2R 10,11
	RCALL SUBOPT_0x14
;     302 tim_aktualne = 0;
	LDI  R30,0
	STS  _tim_aktualne,R30
	STS  _tim_aktualne+1,R30
	STS  _tim_aktualne+2,R30
	STS  _tim_aktualne+3,R30
;     303 rano_vecer = 1;    
	LDI  R30,LOW(1)
	STS  _rano_vecer,R30
;     304 }          
;     305 }
_0x16:
;     306 }
_0x15:
;     307 }
_0x14:
;     308 if(PINB.5==1 & rano_vecer==1) // Setmn 
_0x13:
	LDI  R30,0
	SBIC 0x16,5
	LDI  R30,1
	RCALL SUBOPT_0x15
	PUSH R30
	RCALL SUBOPT_0x16
	POP  R26
	AND  R30,R26
	BREQ _0x17
;     309 {
;     310 delay_ms(2);
	RCALL SUBOPT_0xC
;     311 if(PINB.5==1) 
	SBIS 0x16,5
	RJMP _0x18
;     312 {
;     313 delay_ms(2);
	RCALL SUBOPT_0xC
;     314 if(PINB.5==1)
	SBIS 0x16,5
	RJMP _0x19
;     315 {
;     316 delay_ms(2);
	RCALL SUBOPT_0xC
;     317 if(PINB.5==1) 
	SBIS 0x16,5
	RJMP _0x1A
;     318 { 
;     319 tim_volba = tim_stmivani * 600;
	__GETW2R 12,13
	RCALL SUBOPT_0x14
;     320 tim_aktualne = tim_volba;
	LDS  R30,_tim_volba
	LDS  R31,_tim_volba+1
	CLR  R22
	CLR  R23
	STS  _tim_aktualne,R30
	STS  _tim_aktualne+1,R31
	STS  _tim_aktualne+2,R22
	STS  _tim_aktualne+3,R23
;     321 rano_vecer = 0; 
	RCALL SUBOPT_0xE
;     322 }
;     323 }
_0x1A:
;     324 }
_0x19:
;     325 }
_0x18:
;     326 //******************************************************  
;     327 
;     328 #asm("WDR");
_0x17:
	WDR
;     329 f_aktual = tim_aktualne;
	LDS  R30,_tim_aktualne
	LDS  R31,_tim_aktualne+1
	LDS  R22,_tim_aktualne+2
	LDS  R23,_tim_aktualne+3
	RCALL __CDF1
	STS  _f_aktual,R30
	STS  _f_aktual+1,R31
	STS  _f_aktual+2,R22
	STS  _f_aktual+3,R23
;     330 f_volba = tim_volba;
	LDS  R30,_tim_volba
	LDS  R31,_tim_volba+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	STS  _f_volba,R30
	STS  _f_volba+1,R31
	STS  _f_volba+2,R22
	STS  _f_volba+3,R23
;     331 f_vykon = tim_vykon; 
	LDS  R30,_tim_vykon
	LDS  R31,_tim_vykon+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	STS  _f_vykon,R30
	STS  _f_vykon+1,R31
	STS  _f_vykon+2,R22
	STS  _f_vykon+3,R23
;     332 
;     333 OCR2 = (int)(vykon_aktualne / 3.92);
	LDS  R30,_vykon_aktualne
	LDS  R31,_vykon_aktualne+1
	RCALL SUBOPT_0xA
	__GETD1N 0x407AE148
	RCALL SUBOPT_0xB
	OUT  0x23,R30
;     334 
;     335 if(PINC.3==0 | PINC.4==0 | PINC.5==0)zobrazeni_nastaveni();  // zobrazen nastaven nebo provozu 
	LDI  R30,0
	SBIC 0x13,3
	LDI  R30,1
	RCALL SUBOPT_0x13
	PUSH R30
	LDI  R30,0
	SBIC 0x13,4
	LDI  R30,1
	RCALL SUBOPT_0x13
	POP  R26
	OR   R30,R26
	PUSH R30
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	RCALL SUBOPT_0x13
	POP  R26
	OR   R30,R26
	BREQ _0x1B
	RCALL _zobrazeni_nastaveni
;     336 
;     337 
;     338  
;     339 //------------------------------------------------------
;     340 if(PINC.3==1 & PINC.4==1 & PINC.5==1 & rano_vecer==1) // Rozednn
_0x1B:
	LDI  R30,0
	SBIC 0x13,3
	LDI  R30,1
	RCALL SUBOPT_0x15
	PUSH R30
	LDI  R30,0
	SBIC 0x13,4
	LDI  R30,1
	RCALL SUBOPT_0x15
	POP  R26
	AND  R30,R26
	PUSH R30
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	RCALL SUBOPT_0x15
	POP  R26
	AND  R30,R26
	PUSH R30
	RCALL SUBOPT_0x16
	POP  R26
	AND  R30,R26
	BRNE PC+2
	RJMP _0x1C
;     341 {
;     342 if(tim_aktualne < tim_volba) tim_aktualne = tim_aktualne + 1; // zvyovn asu
	LDS  R30,_tim_volba
	LDS  R31,_tim_volba+1
	RCALL SUBOPT_0x17
	RCALL __CPD21
	BRGE _0x1D
	LDS  R30,_tim_aktualne
	LDS  R31,_tim_aktualne+1
	LDS  R22,_tim_aktualne+2
	LDS  R23,_tim_aktualne+3
	__ADDD1N 1
	STS  _tim_aktualne,R30
	STS  _tim_aktualne+1,R31
	STS  _tim_aktualne+2,R22
	STS  _tim_aktualne+3,R23
;     343 vykon_aktualne = (int)((f_aktual / (f_volba/100))*(f_vykon / 10)); 
_0x1D:
	RCALL SUBOPT_0x18
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x19
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x1A
;     344 if(vykon_aktualne > 1005) vykon_aktualne = 0;
	BRSH _0x1E
	LDI  R30,0
	STS  _vykon_aktualne,R30
	STS  _vykon_aktualne+1,R30
;     345 vykon_lcd = (int)(vykon_aktualne / 10);
_0x1E:
	RCALL SUBOPT_0x1B
;     346  
;     347 minuty = (int)(tim_aktualne / 600);
;     348 sekundy = (int)((tim_aktualne - (minuty * 600)) / 10);
	RCALL SUBOPT_0x1C
;     349 
;     350 lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;     351 lcd_putsf("Den     "); 
	__POINTW1FN _0,64
	RCALL SUBOPT_0x1
;     352 pozice = 7;
	RCALL SUBOPT_0x1D
;     353 if(vykon_lcd >= 100) pozice = pozice - 1;  
	BRLO _0x1F
	RCALL SUBOPT_0x4
;     354 if(vykon_lcd >= 10) pozice = pozice - 1;  
_0x1F:
	RCALL SUBOPT_0x1E
	BRLO _0x20
	RCALL SUBOPT_0x4
;     355 lcd_gotoxy(pozice,0);
_0x20:
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
;     356 itoa(vykon_lcd, LCDn);
	RCALL SUBOPT_0x7
;     357 lcd_puts(LCDn);
	RCALL SUBOPT_0x21
;     358 
;     359 lcd_gotoxy(0,1);    
	RCALL SUBOPT_0x3
;     360 lcd_putsf("        ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x1
;     361 pozice = 1;
	RCALL SUBOPT_0x22
;     362 if(minuty >= 10) pozice = pozice - 1;  
	BRLO _0x21
	RCALL SUBOPT_0x4
;     363 lcd_gotoxy(pozice,1);
_0x21:
	RCALL SUBOPT_0x5
;     364 itoa(minuty, LCDn);
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x7
;     365 lcd_puts(LCDn);
	RCALL _lcd_puts
;     366 lcd_putsf(":");
	__POINTW1FN _0,73
	RCALL SUBOPT_0x1
;     367 if(sekundy >= 10) lcd_gotoxy(3,1);
	RCALL SUBOPT_0x24
	BRLO _0x22
	LDI  R30,LOW(3)
	RJMP _0x31
;     368 else 
_0x22:
;     369 {
;     370 lcd_gotoxy(3,1);
	RCALL SUBOPT_0x25
;     371 lcd_putsf("0");
	__POINTW1FN _0,75
	RCALL SUBOPT_0x1
;     372 lcd_gotoxy(4,1);
	LDI  R30,LOW(4)
_0x31:
	ST   -Y,R30
	RCALL SUBOPT_0x3
;     373 }
;     374 itoa(sekundy, LCDn);
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x7
;     375 lcd_puts(LCDn);
	RCALL _lcd_puts
;     376 } 
;     377 //------------------------------------------------------
;     378 
;     379 
;     380 #asm("WDR");
_0x1C:
	WDR
;     381 //------------------------------------------------------
;     382 
;     383 if(PINC.3==1 & PINC.4==1 & PINC.5==1 & rano_vecer==0) // Setmn   
	LDI  R30,0
	SBIC 0x13,3
	LDI  R30,1
	RCALL SUBOPT_0x15
	PUSH R30
	LDI  R30,0
	SBIC 0x13,4
	LDI  R30,1
	RCALL SUBOPT_0x15
	POP  R26
	AND  R30,R26
	PUSH R30
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	RCALL SUBOPT_0x15
	POP  R26
	AND  R30,R26
	PUSH R30
	RCALL SUBOPT_0x11
	POP  R26
	AND  R30,R26
	BRNE PC+2
	RJMP _0x24
;     384 {
;     385 if(tim_aktualne > 0) tim_aktualne = tim_aktualne - 1; // sniovn asu
	LDS  R26,_tim_aktualne
	LDS  R27,_tim_aktualne+1
	LDS  R24,_tim_aktualne+2
	LDS  R25,_tim_aktualne+3
	RCALL __CPD02
	BRGE _0x25
	LDS  R30,_tim_aktualne
	LDS  R31,_tim_aktualne+1
	LDS  R22,_tim_aktualne+2
	LDS  R23,_tim_aktualne+3
	__SUBD1N 1
	STS  _tim_aktualne,R30
	STS  _tim_aktualne+1,R31
	STS  _tim_aktualne+2,R22
	STS  _tim_aktualne+3,R23
;     386 vykon_aktualne = (int)((f_aktual / (f_volba/100))*(f_vykon/10));    
_0x25:
	RCALL SUBOPT_0x18
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x19
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x1A
;     387 if(vykon_aktualne > 1005) vykon_aktualne = 0;
	BRSH _0x26
	LDI  R30,0
	STS  _vykon_aktualne,R30
	STS  _vykon_aktualne+1,R30
;     388 vykon_lcd = (int)(vykon_aktualne / 10);  
_0x26:
	RCALL SUBOPT_0x1B
;     389 
;     390 minuty = (int)(tim_aktualne / 600);
;     391 sekundy = (int)((tim_aktualne - (minuty * 600)) / 10);
	RCALL SUBOPT_0x1C
;     392 
;     393 lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x0
	RCALL _lcd_gotoxy
;     394 lcd_putsf("Noc     "); 
	__POINTW1FN _0,77
	RCALL SUBOPT_0x1
;     395 pozice = 7;
	RCALL SUBOPT_0x1D
;     396 if(vykon_lcd >= 100) pozice = pozice - 1;  
	BRLO _0x27
	RCALL SUBOPT_0x4
;     397 if(vykon_lcd >= 10) pozice = pozice - 1;  
_0x27:
	RCALL SUBOPT_0x1E
	BRLO _0x28
	RCALL SUBOPT_0x4
;     398 lcd_gotoxy(pozice,0);
_0x28:
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
;     399 itoa(vykon_lcd, LCDn);
	RCALL SUBOPT_0x7
;     400 lcd_puts(LCDn);
	RCALL SUBOPT_0x21
;     401 
;     402 lcd_gotoxy(0,1);    
	RCALL SUBOPT_0x3
;     403 lcd_putsf("        ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x1
;     404 pozice = 1;
	RCALL SUBOPT_0x22
;     405 if(minuty >= 10) pozice = pozice - 1;  
	BRLO _0x29
	RCALL SUBOPT_0x4
;     406 lcd_gotoxy(pozice,1);
_0x29:
	RCALL SUBOPT_0x5
;     407 itoa(minuty, LCDn);
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x7
;     408 lcd_puts(LCDn);
	RCALL _lcd_puts
;     409 lcd_putsf(":");
	__POINTW1FN _0,73
	RCALL SUBOPT_0x1
;     410 if(sekundy >= 10) lcd_gotoxy(3,1);
	RCALL SUBOPT_0x24
	BRLO _0x2A
	LDI  R30,LOW(3)
	RJMP _0x32
;     411 else 
_0x2A:
;     412 {
;     413 lcd_gotoxy(3,1);
	RCALL SUBOPT_0x25
;     414 lcd_putsf("0");
	__POINTW1FN _0,75
	RCALL SUBOPT_0x1
;     415 lcd_gotoxy(4,1);
	LDI  R30,LOW(4)
_0x32:
	ST   -Y,R30
	RCALL SUBOPT_0x3
;     416 }
;     417 itoa(sekundy, LCDn);
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x7
;     418 lcd_puts(LCDn);
	RCALL _lcd_puts
;     419 }
;     420 //------------------------------------------------------
;     421 
;     422 
;     423   
;     424 
;     425       };
_0x24:
	RJMP _0xF
;     426 }
_0x2C:
	RJMP _0x2C
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x27
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0x10
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x27
	RCALL __lcd_ready
	RCALL SUBOPT_0xF
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x2E
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x0
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2E:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
_lcd_putsf:
    ld   r30,y
    ldd  r31,y+1
__lcd_putsf0:
	lpm
    tst  r0
    breq __lcd_putsf1
    adiw r30,1
    st   -y,r0
    rcall _lcd_putchar
    rjmp __lcd_putsf0
__lcd_putsf1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x28
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x27
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x27
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x27
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0x2F
	LDI  R30,LOW(0)
	RJMP _0x30
_0x2F:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x27
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x30:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(2)
	STS  _pozice,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x4:
	LDS  R30,_pozice
	SUBI R30,LOW(1)
	STS  _pozice,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	LDS  R30,_pozice
	ST   -Y,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(_LCDn)
	LDI  R31,HIGH(_LCDn)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x7:
	RCALL _itoa
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	MOVW R26,R30
	MOVW R24,R22
	CLR  R24
	CLR  R25
	RCALL __CDF2
	__GETD1N 0x41087AE1
	RCALL __DIVF21
	RCALL __CFD1
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	MOVW R26,R30
	MOVW R24,R22
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL __DIVF21
	RCALL __CFD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(0)
	STS  _rano_vecer,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	LDS  R26,_rano_vecer
	LDI  R30,LOW(0)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x12:
	RCALL _smycka_menic
	RJMP _smycka_menic

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x13:
	LDI  R26,LOW(0)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL __MULW12U
	STS  _tim_volba,R30
	STS  _tim_volba+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x15:
	LDI  R26,LOW(1)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDS  R26,_rano_vecer
	LDI  R30,LOW(1)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x17:
	LDS  R26,_tim_aktualne
	LDS  R27,_tim_aktualne+1
	LDS  R24,_tim_aktualne+2
	LDS  R25,_tim_aktualne+3
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDS  R26,_f_volba
	LDS  R27,_f_volba+1
	LDS  R24,_f_volba+2
	LDS  R25,_f_volba+3
	__GETD1N 0x42C80000
	RCALL __DIVF21
	LDS  R26,_f_aktual
	LDS  R27,_f_aktual+1
	LDS  R24,_f_aktual+2
	LDS  R25,_f_aktual+3
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDS  R26,_f_vykon
	LDS  R27,_f_vykon+1
	LDS  R24,_f_vykon+2
	LDS  R25,_f_vykon+3
	__GETD1N 0x41200000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	RCALL __MULF12
	RCALL __CFD1
	STS  _vykon_aktualne,R30
	STS  _vykon_aktualne+1,R31
	LDS  R26,_vykon_aktualne
	LDS  R27,_vykon_aktualne+1
	LDI  R30,LOW(1005)
	LDI  R31,HIGH(1005)
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDS  R26,_vykon_aktualne
	LDS  R27,_vykon_aktualne+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	STS  _vykon_lcd,R30
	STS  _vykon_lcd+1,R31
	LDS  R26,_tim_aktualne
	LDS  R27,_tim_aktualne+1
	LDS  R24,_tim_aktualne+2
	LDS  R25,_tim_aktualne+3
	__GETD1N 0x258
	RCALL __DIVD21
	STS  _minuty,R30
	LDS  R26,_minuty
	LDI  R27,0
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL __MULW12U
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	RCALL __SUBD21
	__GETD1N 0xA
	RCALL __DIVD21
	STS  _sekundy,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(7)
	STS  _pozice,R30
	LDS  R26,_vykon_lcd
	LDS  R27,_vykon_lcd+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDS  R26,_vykon_lcd
	LDS  R27,_vykon_lcd+1
	CPI  R26,LOW(0xA)
	LDI  R30,HIGH(0xA)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	LDS  R30,_pozice
	ST   -Y,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	RCALL _lcd_gotoxy
	LDS  R30,_vykon_lcd
	LDS  R31,_vykon_lcd+1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	RCALL _lcd_puts
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(1)
	STS  _pozice,R30
	LDS  R26,_minuty
	CPI  R26,LOW(0xA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	LDS  R30,_minuty
	LDI  R31,0
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	LDS  R26,_sekundy
	CPI  R26,LOW(0xA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDS  R30,_sekundy
	LDI  R31,0
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x27:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x28:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

_itoa:
	ld   r26,y+
	ld   r27,y+
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	brpl __itoa0
	com  r30
	com  r31
	adiw r30,1
	ldi  r22,'-'
	st   x+,r22
__itoa0:
	clt
	ldi  r24,low(10000)
	ldi  r25,high(10000)
	rcall __itoa1
	ldi  r24,low(1000)
	ldi  r25,high(1000)
	rcall __itoa1
	ldi  r24,100
	clr  r25
	rcall __itoa1
	ldi  r24,10
	rcall __itoa1
	mov  r22,r30
	rcall __itoa5
	clr  r22
	st   x,r22
	ret
__itoa1:
	clr	 r22
__itoa2:
	cp   r30,r24
	cpc  r31,r25
	brlo __itoa3
	inc  r22
	sub  r30,r24
	sbc  r31,r25
	brne __itoa2
__itoa3:
	tst  r22
	brne __itoa4
	brts __itoa5
	ret
__itoa4:
	set
__itoa5:
	subi r22,-0x30
	st   x+,r22
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	LDI  R22,0
	LDI  R23,0
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__CWD2:
	LDI  R24,0
	LDI  R25,0
	SBRS R27,7
	RET
	SER  R24
	SER  R25
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

