/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2 Standard
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 15.2.2008
Author  : Martin Satek                    
Company : Akvarista                  
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>   
#include <delay.h> 
#include <stdlib.h> 
#include <math.h> 
#define xtal 16000000

#define SETBIT(ADRESS,BIT)	(ADRESS |=(1<<BIT))
#define CLEARBIT(ADRESS,BIT)	(ADRESS &=~(1<<BIT)) 

#define zarivka 0		// zivky
#define minus 1		        // zporn napt
#define rele 2                  // Rezerva


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12
#endasm
#include <lcd.h>        

unsigned int rozedneni;      
unsigned int stmivani;
unsigned int vykon;    

unsigned int tim_rozedneni;    // [1min]
unsigned int tim_stmivani;     // [1min]
unsigned int tim_vykon;   

long int tim_aktualne;         // aktuln as [0.1s]
unsigned int tim_volba;        // zvolen as se kterm se pracuje [0.1s]
unsigned int vykon_aktualne;   // aktuln vkon [0.1%]
unsigned int vykon_lcd;        // aktuln vkon [%]    
unsigned char menic; 	       //mni napt 
float f_aktual;
float f_volba;
float f_vykon;

char rano_vecer; 
char pozice;     
char minuty;
char sekundy;


int LCDn [4];			// pro zapis cisel na LCD


#define ADC_VREF_TYPE 0x40                  // analogov pevodnk
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

//*****************************************************************
zobrazeni_nastaveni(void){                // pro zadvn parametr
     
if(PINC.3==0){                             // pokud stisknu tlatko
lcd_gotoxy(0,0); 
lcd_putsf("Rano    "); 
pozice = 2;
lcd_gotoxy(0,1);    
lcd_putsf("        ");
if(tim_rozedneni >= 100) pozice = pozice -1;         // posun sel na LCD
if(tim_rozedneni >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,1);
itoa(tim_rozedneni, LCDn);                       // pepoet sla pro LCD
lcd_puts(LCDn);                                     // zobrazen sla na LCD
lcd_putsf(" min");
};

if(PINC.4==0){
lcd_gotoxy(0,0); 
lcd_putsf("Vecer   "); 
pozice = 2;
lcd_gotoxy(0,1);    
lcd_putsf("        ");
if(tim_stmivani >= 100) pozice = pozice -1;
if(tim_stmivani >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,1);
itoa(tim_stmivani, LCDn);
lcd_puts(LCDn);
lcd_putsf(" min");
};

if(PINC.5==0){
lcd_gotoxy(0,0); 
lcd_putsf("Vykon   ");  
pozice = 2;
lcd_gotoxy(0,1);    
lcd_putsf("        ");
if(tim_vykon >= 100) pozice = pozice -1;
if(tim_vykon >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,1);
itoa(tim_vykon, LCDn);
lcd_puts(LCDn);
lcd_putsf(" %  ");
};



}
//*****************************************************************
vypocet_nastaveni(void){                              // pepoty analogovho rozsahu 1024 na rozsah teba 120 minut

tim_rozedneni = 1 + (int)(rozedneni / 8.53); 

tim_stmivani =  1 + (int)(stmivani / 8.53); 
  
tim_vykon = 50 + (int)(vykon / 20.4); 

}
//*****************************************************************
smycka_menic(void){

delay_ms(2);
SETBIT(PORTB,minus); 
delay_ms(2);  
CLEARBIT(PORTB,minus);    
delay_ms(2);
SETBIT(PORTB,minus); 
delay_ms(2);  
CLEARBIT(PORTB,minus);    
}
//*****************************************************************

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=1 State2=1 State1=1 State0=1 
PORTB=0x0F;
DDRB=0x0F;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

 // Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Phase correct PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x65;   
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AVCC pin
// ADC High Speed Mode: Off
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x87;
SFIOR&=0xEF;

// LCD module initialization
lcd_init(16);

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
WDTCR=0x1F;
WDTCR=0x0F;     

SETBIT(PORTB,rele); 
SETBIT(PORTB,zarivka); 
lcd_gotoxy(0,0);
lcd_putsf("Katka   ");    
lcd_gotoxy(0,1);
lcd_putsf("Pruskova"); 

delay_ms(500);
rano_vecer = 0;
vykon_aktualne = 0;
vykon_lcd = 0;
tim_aktualne = 0;    


while (1)
      {
#asm("WDR");  
rozedneni = read_adc(0);	//as rozednn     
stmivani = read_adc(1);		//as stmvn    
vykon = read_adc(2);		//as vkon   
vypocet_nastaveni();
   
if(rano_vecer==0 & vykon_aktualne==0) SETBIT(PORTB,zarivka);
 
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
smycka_menic();
delay_ms(2);

//******************************************************
if(PINB.5==0 & rano_vecer==0) // Rozednn   
{ 
delay_ms(2);
if(PINB.5==0)
{
delay_ms(2);
if(PINB.5==0)
{
delay_ms(2);
if(PINB.5==0) 
{ 
#asm("WDR");
CLEARBIT(PORTB,rele);   // rel pro vypnut analog. vstupu do pevodnku pi startu
delay_ms(100); 
CLEARBIT(PORTB,zarivka);   
delay_ms(1000);   
SETBIT(PORTB,rele);   
tim_volba = tim_rozedneni * 600;
tim_aktualne = 0;
rano_vecer = 1;    
}          
}
}
}
if(PINB.5==1 & rano_vecer==1) // Setmn 
{
delay_ms(2);
if(PINB.5==1) 
{
delay_ms(2);
if(PINB.5==1)
{
delay_ms(2);
if(PINB.5==1) 
{ 
tim_volba = tim_stmivani * 600;
tim_aktualne = tim_volba;
rano_vecer = 0; 
}
}
}
}
//******************************************************  

#asm("WDR");
f_aktual = tim_aktualne;
f_volba = tim_volba;
f_vykon = tim_vykon; 

OCR2 = (int)(vykon_aktualne / 3.92);

if(PINC.3==0 | PINC.4==0 | PINC.5==0)zobrazeni_nastaveni();  // zobrazen nastaven nebo provozu 


 
//------------------------------------------------------
if(PINC.3==1 & PINC.4==1 & PINC.5==1 & rano_vecer==1) // Rozednn
{
if(tim_aktualne < tim_volba) tim_aktualne = tim_aktualne + 1; // zvyovn asu
vykon_aktualne = (int)((f_aktual / (f_volba/100))*(f_vykon / 10)); 
if(vykon_aktualne > 1005) vykon_aktualne = 0;
vykon_lcd = (int)(vykon_aktualne / 10);
 
minuty = (int)(tim_aktualne / 600);
sekundy = (int)((tim_aktualne - (minuty * 600)) / 10);

lcd_gotoxy(0,0); 
lcd_putsf("Den     "); 
pozice = 7;
if(vykon_lcd >= 100) pozice = pozice - 1;  
if(vykon_lcd >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,0);
itoa(vykon_lcd, LCDn);
lcd_puts(LCDn);

lcd_gotoxy(0,1);    
lcd_putsf("        ");
pozice = 1;
if(minuty >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,1);
itoa(minuty, LCDn);
lcd_puts(LCDn);
lcd_putsf(":");
if(sekundy >= 10) lcd_gotoxy(3,1);
else 
{
lcd_gotoxy(3,1);
lcd_putsf("0");
lcd_gotoxy(4,1);
}
itoa(sekundy, LCDn);
lcd_puts(LCDn);
} 
//------------------------------------------------------


#asm("WDR");
//------------------------------------------------------

if(PINC.3==1 & PINC.4==1 & PINC.5==1 & rano_vecer==0) // Setmn   
{
if(tim_aktualne > 0) tim_aktualne = tim_aktualne - 1; // sniovn asu
vykon_aktualne = (int)((f_aktual / (f_volba/100))*(f_vykon/10));    
if(vykon_aktualne > 1005) vykon_aktualne = 0;
vykon_lcd = (int)(vykon_aktualne / 10);  

minuty = (int)(tim_aktualne / 600);
sekundy = (int)((tim_aktualne - (minuty * 600)) / 10);

lcd_gotoxy(0,0); 
lcd_putsf("Noc     "); 
pozice = 7;
if(vykon_lcd >= 100) pozice = pozice - 1;  
if(vykon_lcd >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,0);
itoa(vykon_lcd, LCDn);
lcd_puts(LCDn);

lcd_gotoxy(0,1);    
lcd_putsf("        ");
pozice = 1;
if(minuty >= 10) pozice = pozice - 1;  
lcd_gotoxy(pozice,1);
itoa(minuty, LCDn);
lcd_puts(LCDn);
lcd_putsf(":");
if(sekundy >= 10) lcd_gotoxy(3,1);
else 
{
lcd_gotoxy(3,1);
lcd_putsf("0");
lcd_gotoxy(4,1);
}
itoa(sekundy, LCDn);
lcd_puts(LCDn);
}
//------------------------------------------------------


  

      };
}
